backend/controllers/AddressController.php
<?php

namespace backend\controllers;

use Yii;
use backend\models\Address;
use backend\models\SearchAddress;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use yii\helpers\ArrayHelper;
use yii\helpers\Html;


/**
 * AddressController implements the CRUD actions for Address model.
 */
class AddressController extends Controller
{
    // public function behaviors()
    // {
    //     return [
    //         'verbs' => [
    //             'class' => VerbFilter::className(),
    //             'actions' => [
    //                 'delete' => ['post'],
    //             ],
    //         ],
    //     ];
    // }

    /**
     * Lists all Address models.
     * @return mixed
     */
    public function actionIndex($parent_id = 0, $type = 1)
    {
        $searchModel = new SearchAddress();
        $params = Yii::$app->request->queryParams;

		$params['SearchAddress']['parent_id'] = $parent_id;
		
        $dataProvider = $searchModel->search($params);
        // $dataProvider = $searchModel->search(Yii::$app->request->queryParams);
		$current = SearchAddress::find()->where(['id'=>$parent_id])->one();

        if(empty($type))
            $type = 1;
        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
            'type' => $type,
            'parents' => SearchAddress::parents($parent_id),
            'parent_id' => $parent_id,
            'current' => $current,			
            // 'name' => $name,
        ]);
    }

    /**
     * Displays a single Address model.
     * @param integer $id
     * @return mixed
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Address model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate($parent_id = 0, $type = 0/**/)
    {
        $temp = SearchAddress::find()->where(['id' => $parent_id])->one();
        $id = $temp['id'];
        $dependency_id = $temp['dependency_id'];
        $name = $temp['name'];
        $type = $temp['type'];

        $model = new Address();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        } else {
            return $this->render('create', [
                'model' => $model,
                'parent_id' => $id,
                'type' => $type+1,
            ]);
        }
    }

    /**
     * Updates an existing Address model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     */
    public function actionUpdate($id)
    {
        $temp = SearchAddress::find()->where(['id' => $id])->one();
        $type = $temp['type'];
        $parent_id = $temp['parent_id'];
        $dependency_id = $temp['dependency_id'];
        $name = $temp['name'];


        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        } else {
            return $this->render('update', [
                'model' => $model,
                'parent_id' => $parent_id,
                'type' => $type,
            ]);
        }
    }

    /**
     * Deletes an existing Address model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     */
    public function actionDelete($id)
    {
        if(SearchAddress::canDelete($id)){
        $this->findModel($id)->delete();
        }

        return $this->redirect(['index']);
    }

    /**
     * Finds the Address model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Address the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Address::findOne($id)) !== null) {
            return $model;
        } else {
            throw new NotFoundHttpException('The requested page does not exist.');
        }
    }
    public function actionList($id = 0/**/)
    {
        $temp = SearchAddress::find()->where(['parent_id' => $id])->all();
        $temp = ArrayHelper::map($temp, 'id', 'name');
        $result =  Html::dropDownList('my-select', NULL, $temp, $options = []);
        return $result;
    }

    public function getFullPath($id = 0 /**/){
        $temp = SearchAddress::parents($id);
        $result = "";
        $result = implode(array_reverse(ArrayHelper::map($temp, 'id', 'name')), " ");
        return $result;

    }
    public function showName($id = 0){
        $result = "";
        $result = SearchAddress::find()->where(['id' => $id])->one()['name'];
        return $result;

    }
}

backend/controllers/RequestController.php
<?php

namespace backend\controllers;

use app\models\Address;
use app\models\CallRequest;
use backend\models\SearchAddress;
use Yii;
use yii\filters\AccessControl;
use yii\filters\VerbFilter;
use yii\helpers\ArrayHelper;
use yii\helpers\Html;
use yii\web\Controller;
use yii\web\NotFoundHttpException;


/**
 * RequestController implements the CRUD actions for CallRequest model.
 */
class RequestController extends Controller
{
    public function init()
    {		
		//$this->bottstrap_css = true;
		Yii::$app->language = 'ru-RU';
	}
	
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'rules' => [
                    [
                        'actions' => ['update'],
                        'allow' => true,
						'roles' => ['request_edit']
                    ],
                    [
                        'actions' => ['done'],
                        'allow' => true,
						'roles' => ['request_done']
                    ],
                    [
                        'actions' => ['index', 'view'],
                        'allow' => true,
						'roles' => ['request_view']
                    ],
                    [
                        'actions' => ['create'],
                        'allow' => true,
						'roles' => ['request_create']
                    ],
                    [
                        'actions' => ['getaddrinp'],
                        'allow' => true,
						//'roles' => ['request_create']
                    ],
                    [
                        'actions' => ['getaddrinp2'],
                        'allow' => true,
						//'roles' => ['request_create']
                    ],
                    [
                        'actions' => ['view-posible-dependency'],
                        'allow' => true,
						//'roles' => ['request_create']
                    ],
                    [
                        'actions' => ['get-sub-crash'],
                        'allow' => true,
						//'roles' => ['request_create']
                    ],
					
                ],
            ],		
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['post'],
                ],
            ],
        ];
    }

    /**
     * Lists all CallRequest models.
     * @return mixed
     */
    public function actionIndex()
    {
        $searchModel = new RequestSearch();
		$queryParams = Yii::$app->request->queryParams;
		if (!array_key_exists('sort', $queryParams))
		{
			return $this->redirect(['index','sort'=>'-id']);
		}

        $dataProvider = $searchModel->search($queryParams);

        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }

	public function actionGetSubCrash($id)
    {
		$a_sub_crash = CallRequest::find()->where(['crash_id'=>$id]);
		$dataProvider = new \yii\data\ActiveDataProvider([
			'query' => $a_sub_crash,
		]);


		return $this->renderPartial('sub_crash_tr', [
            'searchModel' => null,
            'dataProvider' => $dataProvider,
			'only_rec' => true,
        ]);
    }

    /**
     * Displays a single CallRequest model.
     * @param integer $id
     * @return mixed
     */
    public function actionView($id)
    {
        return $this->renderPartial('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new CallRequest model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */

	public function actionCreate()
	{
        $model = new \app\models\CallRequest();
		$model->scenario = 'create';
		
		if(Yii::$app->request->post()==array())
		{
			return $this->renderPartial('m_create', [
				'model' => $model,
				'title' => 'Create Call Request',
			]);
		}
		
		// сохранение
        if($model->load(Yii::$app->request->post()) && $model->validate() && $model->save() /*&& $model->contact(Yii::$app->params['adminEmail'])/**/) 
		{
			$responsible_user = ArrayHelper::getValue(Yii::$app->request->post(), 'CallRequest.responsible_user', array());
			if (!is_array($responsible_user)) $responsible_user = [$responsible_user];
			$model->setResponsibleUsers($responsible_user);
			
            $result=[
				'result'=>true,
				'msg'=>'Сохранено'// . print_r(Yii::$app->request->post('CallRequest')['responsible_user'],1)
			];
            return json_encode($result);
        }
		// если сохранение не удалось или не прошла проверка
        else
        {
            $result=[
				'result'=>false,
				'content'=> $this->renderPartial(
					'm_create', [
						'model' => $model,
						'title' => 'Create Call Request',
					]
				),
				'msg'=>'Ошибка'
			];
            return json_encode($result);			
        }
    }

    /**
     * Updates an existing CallRequest model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     */
    public function actionUpdate($id)
    {
		$model = $this->findModel($id);
		if(Yii::$app->request->post()==array())
		{
			return $this->renderPartial('m_create', [
				'model' => $model,
				'title' => 'Update Call Request',
			]);
		}
		
		$model->scenario = 'update';
		// сохранение
        if($model->load(Yii::$app->request->post()) && $model->validate() && $model->canEdit() && $model->save()) 
		{
            $result=[
				'result'=>true,
				'msg'=>'Сохранено'// . print_r(Yii::$app->request->post('CallRequest')['responsible_user'],1)
			];
            return json_encode($result);
        }
		// если сохранение не удалось или не прошла проверка
        else
        {
            $result=[
				'result'=>false,
				'content'=> $this->renderPartial(
					'm_create', [
						'model' => $model,
						'title' => 'Update Call Request',
					]
				),
				'msg'=>'Ошибка' //. print_r($rr,1)
			];
            return json_encode($result);
        }
    }

    public function actionViewPosibleDependency($id)
    {
		$a_dependency = CallRequest::getPosibleDependencyAddress($id);
		foreach ($a_dependency as &$rec)
		{
			$rec->text = "<div class = \"col-sm-9\"><div>{$rec->address}</div><div>{$rec->comment}</div></div>";
		}
		unset($rec);
		$a_address_history = [];
		
		$a_address_history = CallRequest::find($id)->where(['address_id'=>$id])->all();
		
		return $this->renderPartial('m_posible_dependency', [
			'a_dependency' => $a_dependency,
			'a_address_history' => $a_address_history,
			'title' => 'Зависимость от аварии',
		]);
	}
	
    public function actionDone($id)
    {
		$model = $this->findModel($id);
		if(Yii::$app->request->post()==array())
		{
			return $this->renderPartial('done', [
				'model' => $this->findModel($id),
			]);
		}
		else
		if($model->canEdit())
		{
			$post = Yii::$app->request->post('CallRequest');
			$model->comment_done = ArrayHelper::getValue(Yii::$app->request->post(), 'CallRequest.comment_done', null);
			$model->comment_done = ArrayHelper::getValue(Yii::$app->request->post(), 'CallRequest.comment_done', null);
			$model->time_performed = ArrayHelper::getValue(Yii::$app->request->post(), 'CallRequest.time_performed', null);
			$responsible_user = ArrayHelper::getValue(Yii::$app->request->post(), 'CallRequest.responsible_user', array());
			if (!is_array($responsible_user))
				$responsible_user = [$responsible_user];
			if (implode($responsible_user,'') == '')
				$responsible_user[] = Yii::$app->user->getId();
			$model->scenario = 'done';
			if($model->validate() && $model->save())
			{
				if(Yii::$app->user->can('operator')){
					$model->setResponsibleUsers($responsible_user);
				}
				else
				{
					$model->setResponsibleUser(Yii::$app->user->getId());
				}
				$result=[
					'result'=>true,
					'content'=> $this->renderPartial(
						'done', ['model' => $model]
					),
					'msg'=>'Выполнено'
				];
				return json_encode($result);
			}
			else
			{
				$result=[
					'result'=>!true,
					'content'=> $this->renderPartial(
						'done', ['model' => $model]
					),
					'msg'=>'Ошибка ' . implode($model->getErrors('closed'), ', ')
				];
				return json_encode($result);		
			}
		}
    }

    /**
     * Deletes an existing CallRequest model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the CallRequest model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return CallRequest the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = CallRequest::findOne($id)) !== null) {
            return $model;
        } else {
            throw new NotFoundHttpException('The requested page does not exist.');
        }
    }
	
    public function actionGetaddrinp($id = 0)
    {
		$uu = Yii::$app->request->post();
        $temp = SearchAddress::find()->where(['parent_id' => $id])->orderBy('name')->all();
		array_unshift($temp, ['id'=>0, 'name'=>Yii::t('app', '-select-')]);
        $temp = ArrayHelper::map($temp, 'id', 'name');
        $result =  Html::dropDownList('my-select', NULL, $temp, $options = []); /**/
        return $result;
    }

    public function renderAddrinp($id = 0)
    {
        $temp = SearchAddress::find()->where(['parent_id' => $id])->all();
		array_unshift($temp, ['id'=>0, 'name'=>Yii::t('app', '-select-')]);
        $temp = ArrayHelper::map($temp, 'id', 'name');
		$result =  Html::dropDownList('my-select', NULL, $temp, $options = []);
	}
	
    public function actionGetaddrinp2($id = 0)
    {

backend/views/layouts/main.php
<?php
use backend\assets\AppAsset;
use yii\helpers\Html;
use yii\bootstrap\Nav;
use yii\bootstrap\NavBar;
use yii\widgets\Breadcrumbs;
use yii\helpers\Url;

use webvimark\modules\UserManagement\components\GhostMenu;
use webvimark\modules\UserManagement\UserManagementModule;
/* @var $this \yii\web\View */
/* @var $content string */

AppAsset::register($this);
backend\assets\AdminAsset::register($this);

$roles = Yii::$app->authManager->getRolesByUser(Yii::$app->user->getId());
$roles = yii\helpers\ArrayHelper::getColumn($roles, 'name');
$roles = implode($roles, ' ');
?>

<?php $this->beginPage() ?>
<!DOCTYPE html>
<html lang="<?= Yii::$app->language ?>">
<head>
    <meta charset="<?= Yii::$app->charset ?>">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <?= Html::csrfMetaTags() ?>
    <title><?= Html::encode($this->title) ?></title>
    <?php $this->head() ?>
</head>
<body>
    <?= Html::hiddenInput('my-path', Url::toRoute('request/getaddrinp'), ['id' => 'j_path_addr_inp']) ?>
    <?= Html::hiddenInput('my-path', Url::toRoute('request/view-posible-dependency'), ['id' => 'j_view_posible_dependency_inp']) ?>
    <?= Html::hiddenInput('my-path', Url::toRoute('request/get-sub-crash'), ['id' => 'j_view_get_sub_crash']) ?>
    <?php $this->beginBody() ?>
	<?//=Yii::$app->hasRole('group')?>
    <div class="wrap">
        <?php
            NavBar::begin([
                'brandLabel' => '<img src="'.Url::to('img/logocallcenter.jpg').'" class="img img-responsive" style="width:251px; height:auto;">',
                'brandUrl' => Yii::$app->homeUrl,
                'options' => [
                    'class' => 'navbar-inverse navbar-fixed-top',
                   ],
            ]);
			
            $menuItems = [
                //['label' => 'Requests', 'url' => ['/request/index']],
					['label' => 'Заявки', 'url' => ['/request/index']],
            ];
			if (Yii::$app->user->can('request_type_edit'))
				$menuItems[] = ['label' => 'Типы заявок', 'url' => ['/call-type/index']];
			if (Yii::$app->user->can('address_edit'))
				$menuItems[] = ['label' => 'Адреса', 'url' => ['/address/index']];
			if (Yii::$app->user->can('аdmin'))
				$menuItems[] = ['label' => 'Пользователи и права', 'url' => ['/user-management/user/index']];
            if (Yii::$app->user->isGuest) {
                $menuItems[] = ['label' => 'Login', 'url' => ['/site/login']];
            } else {
                $menuItems[] = [
                    'label' => 'Logout (' . Yii::$app->user->identity->username . ')' . " [{$roles}]",
                    'url' => ['/site/logout'],
                    'linkOptions' => ['data-method' => 'post']
                ];
            }
            echo Nav::widget([
                'options' => ['class' => 'navbar-nav navbar-left'],
                'items' => $menuItems,
            ]);
            NavBar::end();
        ?>

        <div class="my-container">
		<pre></pre>
        <?= Breadcrumbs::widget([
            'links' => isset($this->params['breadcrumbs']) ? $this->params['breadcrumbs'] : [],
        ]) ?>

	  <?if(Yii::$app->controller->module->id == 'user-management'){?>
		<div class="col-md-3">
		<?		
		echo GhostMenu::widget([
			'encodeLabels'=>false,
			'activateParents'=>true,
			'options' => [
				'class'=>'role-menu',
			],
			'items' => [
				[
					'label' => 'Админская часть',
					'items'=>UserManagementModule::menuItems()
				],
				[
					'label' => 'Frontend routes',
					'items'=>[
						['label'=>'Login', 'url'=>['/user-management/auth/login']],
						['label'=>'Logout', 'url'=>['/user-management/auth/logout']],
						['label'=>'Registration', 'url'=>['/user-management/auth/registration']],
						['label'=>'Change own password', 'url'=>['/user-management/auth/change-own-password']],
						['label'=>'Password recovery', 'url'=>['/user-management/auth/password-recovery']],
						['label'=>'E-mail confirmation', 'url'=>['/user-management/auth/confirm-email']],
					],
				],
			],
		]);/**/
		?>
        </div>
		<?}?>
		
		<?if(Yii::$app->controller->module->id == 'user-management'){?>
		<div class="col-md-9">
		<?}?>
			<?= $content ?>
		<?if(Yii::$app->controller->module->id == 'user-management'){?>
		</div>
		<?}?>
		</div>
    </div>

	<footer class="footer">
		<div class="container">
			<p class="pull-left">&copy; SkyGroup Ltd.</p>
			<p class="pull-right">Powered by <a rel="external" href="http://www.techworldsoft.com/">TechWorld Software</a></p>
		</div>
	</footer>

	<div class="modal fade" id="modal-req" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
	   <div class="modal-dialog modal-sm_">
		 <div class="modal-content">
		   <div class="modal-body">
			 ...
		   </div>
		 </div><!-- /.modal-content -->
	   </div><!-- /.modal-dialog -->
	</div><!-- /.modal -->

	<div class="modal fade" id="modal-check-crash" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
	   <div class="modal-dialog modal-sm_">
		 <div class="modal-content">
		   <div class="modal-body">
			 ...
		   </div>
		 </div><!-- /.modal-content -->
	   </div><!-- /.modal-dialog -->
	</div><!-- /.modal -->
    <?php $this->endBody() ?>
</body>
</html>
<?php $this->endPage() ?>

backend/views/layouts/user_management.php
<?php
use backend\assets\AppAsset;
use yii\helpers\Html;
use yii\bootstrap\Nav;
use yii\bootstrap\NavBar;
use yii\widgets\Breadcrumbs;

use webvimark\modules\UserManagement\components\GhostMenu;
use webvimark\modules\UserManagement\UserManagementModule;

AppAsset::register($this);
backend\assets\AdminAsset::register($this);

?>

<?php $this->beginPage() ?>
<!DOCTYPE html>
<html lang="<?= Yii::$app->language ?>">
<head>
    <meta charset="<?= Yii::$app->charset ?>">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <?= Html::csrfMetaTags() ?>
    <title><?= Html::encode($this->title) ?></title>
    <?php $this->head() ?>
</head>
<body>
    <?php $this->beginBody() ?>
    <div class="wrap">
        <?php
            NavBar::begin([
                'brandLabel' => '<img src="/call_center/site/advanced/backend/web/img/logocallcenter.gif">',
                'brandUrl' => Yii::$app->homeUrl,
                'options' => [
                    'class' => 'navbar-inverse navbar-fixed-top',
                ],
            ]);
            $menuItems = [
                //['label' => 'Requests', 'url' => ['/request/index']],
					['label' => 'Заявки', 'url' => ['/request/index']],
					['label' => 'Типы заявок', 'url' => ['/call-type/index']],
            ];
            if (Yii::$app->user->isGuest) {
                $menuItems[] = ['label' => 'Login', 'url' => ['/site/login']];
            } else {
                $menuItems[] = [
					
                    'label' => 'Logout (' . Yii::$app->user->identity->username . ')',
                    'url' => ['/site/logout'],
                    'linkOptions' => ['data-method' => 'post']
                ];
            }
            echo Nav::widget([
                'options' => ['class' => 'navbar-nav navbar-left'],
                'items' => $menuItems,
            ]);
            NavBar::end();
        ?>

        <div class="my-container" style="width:90%; margin: 0 auto;">
        <?= Breadcrumbs::widget([
            'links' => isset($this->params['breadcrumbs']) ? $this->params['breadcrumbs'] : [],
        ]) ?>
        <?= $content ?>
        </div>
		<?php
			{
            echo GhostMenu::widget([
                'encodeLabels'=>false,
                'activateParents'=>true,
                'items' => [
                    [
                        'label' => 'Backend routes',
                        'items'=>UserManagementModule::menuItems()
                    ],
                    [
                        'label' => 'Frontend routes',
                        'items'=>[
                            ['label'=>'Login', 'url'=>['/user-management/auth/login']],
                            ['label'=>'Logout', 'url'=>['/user-management/auth/logout']],
                            ['label'=>'Registration', 'url'=>['/user-management/auth/registration']],
                            ['label'=>'Change own password', 'url'=>['/user-management/auth/change-own-password']],
                            ['label'=>'Password recovery', 'url'=>['/user-management/auth/password-recovery']],
                            ['label'=>'E-mail confirmation', 'url'=>['/user-management/auth/confirm-email']],
                        ],
                    ],
                ],
            ]);/**/
			}
            ?>        
    </div>
    <footer class="footer">
        <div class="container">
        <p class="pull-left">&copy; Call center <?= date('Y') ?></p>
        <p class="pull-right"><?= Yii::powered() ?></p>
        </div>
    </footer>
    <?php $this->endBody() ?>
</body>
</html>
<?php $this->endPage() ?>